<?php

namespace Queue\Src;

use Dever;

class Queue implements Core
{
	private $db;
	private $key;

	public function __construct()
	{
		$db = 'Queue\\Src\\' . ucfirst(Dever::config('base')->queue['method']);
		$this->db = new $db();
	}

	private function key($key = false)
	{
		if (!$key) {
			$key = DEVER_PROJECT . '_' . DEVER_APP_NAME;
		}
		return $key;
	}

	public function push($value, $key = false)
	{
		$value = json_encode($value, JSON_UNESCAPED_UNICODE);
		return $this->db->push($value, $this->key($key));
	}

	public function pop($key = false)
	{
		$data = $this->db->pop($this->key($key));
		return json_decode($data, true);
	}

	public function len($key = false)
	{
		return $this->db->len($this->key($key));
	}

	public function get()
	{
		return $this->db;
	}
}
