<?php

namespace Queue\Src;

use Dever;

class Redis implements Core
{
	private $db;

	public function __construct()
	{
		$this->db = new \Redis;
		$config = Dever::config('base')->queue;

		$host = Dever::config('base')->queue['host'];
		$port = Dever::config('base')->queue['port'];

		$this->db->connect($config['host'], $config['port']);

		if (isset($config['password'])) {
			$this->db->auth($config['password']);
		}
	}

	public function push($value, $key)
	{
		return $this->db->lpush($key, $value);
	}

	public function pop($key)
	{
		$data = $this->db->brPop($key, 10);
        if ($data) {
            if (isset($data[1])) {
                $data = $data[1];
            }
            return $data;
        } else {
            $pong = $this->db->ping();
            if ($pong != '+PONG') {
                throw new \Exception('Redis ping failure!', 500);
            }
            usleep(100000);
        }
        return false;
	}

	public function len($key)
	{
		return $this->db->llen($key);
	}
}
